/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only 
* intended for use with Renesas products. No other uses are authorized. This 
* software is owned by Renesas Electronics Corporation and is protected under 
* all applicable laws, including copyright laws.
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIES REGARDING 
* THIS SOFTWARE, WHETHER EXPRESS, IMPLIED OR STATUTORY, INCLUDING BUT NOT 
* LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE 
* AND NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.
* TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY LAW, NEITHER RENESAS 
* ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE 
* FOR ANY DIRECT, INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR 
* ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR ITS AFFILIATES HAVE 
* BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software 
* and to discontinue the availability of this software.  By using this software, 
* you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2015 Renesas Electronics Corporation. All rights re
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_cg_it_user.c
* Version      : 
* Device(s)    : R5F117GCG
* Tool-Chain   : IAR Systems iccrl78
* Description  : This file implements device driver for IT module.
* Creation Date: 10/01/2015
***********************************************************************************************************************/

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_it.h"
/* Start user code for include. Do not edit comment generated here */
#include "r_cg_adc.h"
#include "r_cg_cmp.h"
#include "r_cg_amp.h"
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
uint16_t g100msTick;
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
* Function Name: r_it_interrupt
* Description  : This function is INTIT interrupt service routine.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
#pragma vector = INTIT_vect
__interrupt static void r_it_interrupt(void)
{
    /* Start user code. Do not edit comment generated here */
    g100msTick++;
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: r_it00_interrupt
* Description  : This function is INTIT00 interrupt service routine.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
#pragma vector = INTIT00_vect
__interrupt static void r_it00_interrupt(void)
{
    /* Start user code. Do not edit comment generated here */
    
    switch(amp_state)
    {
        case AMP_STATE_START:
            amp_state = AMP_STATE_IREF;
            IREFE = 1U;	
            break;
        case AMP_STATE_IREF:
            amp_state = AMP_STATE_PRECHARGE;
            AMPC |= 0x03U;              /* Enable AMP0 and AMP1 */
            break;
        case AMP_STATE_PRECHARGE:
            amp_state = AMP_STATE_DONE_PRECHARGE;
            AMPPC0 = 1U;                /* Enable precharge */
            AMPPC1 = 1U;
            R_IT00_Stop();  
            TRTCMP1  = 205;                      /* 200mS to precharge external cap */    
            R_IT10_Start();             
            break;
        default:
	    // Shall not occur.
            break;
    }
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: r_it10_interrupt
* Description  : This function is INTIT10 interrupt service routine.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
#pragma vector = INTIT10_vect
__interrupt static void r_it10_interrupt(void)
{
    /* Start user code. Do not edit comment generated here */
    switch(amp_state)
    {
        case AMP_STATE_DONE_PRECHARGE:
            amp_state = AMP_STATE_OPERATING;
            AMPPC0 = 0U;                /* Done with precharge */
            AMPPC1 = 0U;
            R_CMP0_Start();
            R_IT10_Stop();             
            break;
        case AMP_STATE_HPF_START:
            amp_state = AMP_STATE_HPF_OPERATING;
            R_IT10_Stop();
            R_CMP1_Start();
            gCMP1_int = 0U;
            TRTCMP1  = 205;                      /* 200mS */    
            R_IT10_Start();
            break;
        case AMP_STATE_HPF_OPERATING:
            amp_state = AMP_STATE_FALSE_ALARM;
            R_CMP1_Stop();
            AMP_HPF_Stop();
            R_IT10_Stop();
            break;
        default:
	    // Shall not occur.
            break;
    }
    
    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */
